unit ScoreEditor;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, MPlayer, AppEvnts, DXDraws, Menus ,MMSystem ,UConsts ,DXClass,
  DXSounds, StdCtrls, Buttons, ComCtrls, DXInput, Ddidex;

const
  BARX = 25;
  ASTICK_POWER = 1 / 32767;

type
  TEditMode = (Playing,ADJ,AutoPlay);

  TForm1 = class(TDXForm)
    BGM1: TMediaPlayer;
    OD1: TOpenDialog;
    AE1: TApplicationEvents;
    DXDraw1: TDXDraw;
    DXSound1: TDXSound;
    Sounds: TDXWaveList;
    SpeedButton2: TSpeedButton;
    Speed1: TTrackBar;
    Label2: TLabel;
    Input1: TDDIDEX;
    procedure FormDestroy(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure AE1Idle(Sender: TObject; var Done: Boolean);
    procedure FormShow(Sender: TObject);
    procedure DXDraw1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure DXDraw1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure DXDraw1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure SpeedButton2Click(Sender: TObject);
    procedure Speed1Change(Sender: TObject);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

  PBar = ^TBar;
  TBar = record
    Kind:Byte;
    Timing:integer;
    Y:integer;
    Hitted:Boolean;
  end;

  {y}
  TScore = class(TList)
    function Get(Index: Integer): PBar;
    procedure Put(Index: Integer; const Value: PBar);
  public
    constructor Create();
    destructor Destroy();override;

    property Items[Index: Integer]: PBar read Get write Put; default;

    procedure Add(const Tim:Integer;Kin:Byte);overload;
    procedure SaveScore(Str: String);
    procedure LoadScore(FN1:string);
    procedure Reborn();
  end;

  function SortComp(Item1, Item2: Pointer): Integer;
  function HitCheck(const RectA,RectB:TRect):boolean;
  function CreateBar(NewKind: Byte; NewTiming: integer) : PBar;

const
  EFPS = 16.66;

var
  Form1: TForm1;

implementation

{$R *.dfm}
var
  Score :TScore;
  ExePath:String;
  EditMode:TEditMode = ADJ;
  Mouse1:TPoint;
  MB:PBar;
  BarHei:integer;
  Rec:TRect;//I͈
  RecMoving:Boolean = false;
  Pow : double = 0.5;
  OldButtons:array[DI_B1..DI_B10] of Boolean;
  BGMPosition : integer;

function CreateBar(NewKind: Byte; NewTiming: integer) : PBar;
var
  Bar :PBar;
begin
  New(Bar);
  with Bar^ do
  begin
    Kind:=NewKind;
    Timing:=NewTiming;
    Hitted:=False;
  end;
  Result := Bar;
end;


procedure TForm1.FormDestroy(Sender: TObject);
begin
  TimeEndPeriod(1);
  FreeAndNil(Score);
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  if BGM1.Mode = mpPlaying then BGM1.Stop();
  EditMode:=ADJ;
  if MessageDlg('Z[u܂H',mtConfirmation,[mbYes,mbNo],0) <> mrYes then exit;
  Score.SaveScore(OD1.FileName);
end;

var
  NowTime,Beforetime:Int64;
  Tick:integer;
procedure TForm1.AE1Idle(Sender: TObject;
  var Done: Boolean);
procedure AddScore(Num:Byte);
begin
  Score.Add(BGMPosition,Num);
  Sounds.Items[Num - 1].Play(False);
  Score.Sort(SortComp);
end;
var
  i:integer;

begin
  NowTime := timeGetTime;
  if (NowTime - BeforeTime) <= EFPS then
  begin
    Sleep(0);
    Done := False;
    Exit;
  end;
  Input1.OrScan([DI_JOY1,DI_KEYB]);
  BGMPosition := BGM1.Position;
  inc(Tick);
  Mouse1.X :=Mouse.CursorPos.X - Left - 5;
  Mouse1.Y :=Mouse.CursorPos.Y - Top - 32;
  case EditMode of
    Playing:begin
      with BGM1 do
      begin
        if Mode = mpPlaying then
        begin
          if (Input1.Buttons[DI_B1]) and (not Oldbuttons[DI_B1]) then AddScore(1);
          if (Input1.Buttons[DI_B2]) and (not Oldbuttons[DI_B2]) then AddScore(2);
          if (Input1.Buttons[DI_B3]) and (not Oldbuttons[DI_B3]) then AddScore(3);
          if (Input1.Buttons[DI_B4]) and (not Oldbuttons[DI_B4]) then AddScore(4);
          if (Input1.Buttons[DI_B5]) and (not Oldbuttons[DI_B5]) then AddScore(5);
          if (Input1.Buttons[DI_B6]) and (not Oldbuttons[DI_B6]) then AddScore(6);
          if (Input1.Buttons[DI_B7]) and (not Oldbuttons[DI_B7]) then AddScore(7);
          if (Input1.Buttons[DI_B8]) and (not Oldbuttons[DI_B8]) then AddScore(8);
        end
          else
        begin
          Play();
        end;

      end;
    end;

    AutoPlay:begin
      with BGM1 do
      begin
        if Mode <> mpPlaying then
        begin
          Play();
          for i := 0 to Score.Count - 1 do
          begin
            if -(Score[i].Timing - BGMPosition) >= 0 then
              Score[i].Hitted:=True;
          end;
        end
          else
        begin
          for i := 0 to Score.Count - 1 do
          begin
            if Score[i].Hitted then continue;
            if -(Score[i].Timing - BGMPosition) >= 0 then
            begin
              Sounds.Items[Score[i].Kind - 1].Play(False);
              Score[i].Hitted:=True;
            end;
          end;

        end;

      end;
    end;



    ADJ:begin
      BGM1.Pause();
      for i:= 0 to Score.Count - 1 do
      begin
        Score[i].Hitted :=False;
      end;
      if (GetKeyState(VK_LButton) < 0) and (not RecMoving) and (Mouse1.Y < 600) then
      begin
        if MB <> nil then
        begin
          with MB^ do
          begin
            Timing:=Trunc((-Mouse1.Y + JUSTPOSI) / Pow + BGMPosition);
            if GetKeyState(VK_RButton) < 0 then
            begin
              for i:= 0 to Score.Count - 1 do
              begin
                if Score[i] = MB then
                begin
                  Dispose(Score[i]);
                  Score.Delete(i);
                  MB:=nil;
                  break;
                end;
              end;
            end;
          end;
        end
          else
        begin
          for i:= 0 to Score.Count - 1 do
          begin
            if HitCheck(Rect(Mouse1,Point(Mouse1.X + 1,Mouse1.Y + 1)),
                        Rect(BARX,Score[i].Y-11,BARX + 50,Score[i].Y +11)
                        ) then MB:=Score[i];
          end;
        end;
      end
        else MB:=nil;
    end;
  end;
  if ((Tick mod 2 = 0) and (EditMode <> AutoPlay)) or
     ((Tick mod 12 = 0) and (EditMode = AutoPlay)) then
  begin
    DXDraw1.Surface.Fill(0);
    {Canvas`}
    with DXDraw1.Surface.Canvas do
    begin
      {qbg][}
      Pen.Width:=3;
      Pen.Color:=clwhite;
      MoveTo(0,JUSTPOSI);
      LineTo(DXDraw1.Surface.Width,JUSTPOSI);

      Brush.Color:=clred;
      Pen.Color:=clblue;
      if RecMoving then FrameRect(Rec);

      Brush.Color := clBlack;
      for i:= 0 to Score.Count - 1 do
      begin
        with Score[i]^ do
        begin
          case Kind of
            0:Pen.Color:=clwhite;
            1:Pen.Color:=clyellow;
            2:Pen.Color:=cllime;
            3:Pen.Color:=claqua;
            4:Pen.Color:=clred;
            5:Pen.Color:=clsilver;
            6:Pen.Color:=clfuchsia;
            7:Pen.Color:=$215297;
            8:Pen.Color:=$878124;
          end;
          Font.Color := Pen.Color;
          Y:=JUSTPOSI - Trunc((Timing - BGMPosition) * Pow);
          if (Y > 0) and (Y < DXDraw1.Height) then
          begin
            if not Hitted then
            begin
              MoveTo(BARX,Y-BarHei div 2);
              LineTo(BARX + 50,Y-BarHei div 2);
            end;
            TextOut(BARX - 20,Y,IntToStr(Kind))
          end;
        end;
      end;

      Release;
    end;

    DXDraw1.Flip();
  end;

  if (Input1.Buttons[DI_B10]) and
     (not OldButtons[DI_B10]) and
     (EditMode in [Playing,ADJ]) then
  begin
    if EditMode = ADJ then
    begin
      EditMode:=Playing;
    end
      else
    begin
      EditMode:=ADJ;
      Score.SaveScore(ExtractFilePath(OD1.FileName) + 'BackUp_' + ExtractFileName(OD1.FileName));
      Sleep(100);
    end;
  end;
  if (Input1.Buttons[DI_B9]) and
     (not OldButtons[DI_B9]) and
     (EditMode in [AutoPlay,ADJ]) then
  begin
    if EditMode = AutoPlay then
    begin
      EditMode:=ADJ;
      Score.Reborn();
    end
      else
    begin
      EditMode:=AutoPlay;
    end;
  end;

  for i:= DI_B1 to DI_B10 do
  begin
    OldButtons[i]:= Input1.Buttons[i];
  end;

  if (EditMode = ADJ) and (Tick mod 3 = 0) then
  begin
    if BGM1.Position - Trunc(Input1.AStick.Y * ASTICK_POWER * 300) < 0 then
      BGM1.Position := 0
    else
      BGM1.Position := BGM1.Position - Trunc(Input1.AStick.Y * ASTICK_POWER * 300);
  end;
  BGM1.StartPos := BGM1.Position;
  BeforeTime := NowTime;
  Done:=False;
end;

procedure TForm1.FormShow(Sender: TObject);
label ret;
begin
  TimeBeginPeriod(1);//^C}[xUP
  ExePath:=ExtractFilePath(Application.ExeName);
  Form1.SetFocus();
  BGM1.Wait := true;
  OD1.FileName:='';
  OD1.InitialDir:=ExePath + 'Score\';
  ret:
  if OD1.Execute then
  begin
    Score:=TScore.Create();
    Score.LoadScore(OD1.FileName);
  end else goto ret;
end;

(******************************
      @  y
******************************)
constructor TScore.Create();
begin
  inherited;
  ReBorn();
end;

destructor TScore.Destroy();
var
  i: Integer;
begin
  for i := 0 to Count - 1 do
    Dispose(Self[i]);
  inherited;
end;

procedure TScore.Reborn();
var
  i:integer;
begin
  for i:= 0 to Count - 1 do
  begin
    Items[i].Hitted:=False;
  end;
end;

procedure TScore.LoadScore(FN1:String);
var
  Sco1,ExSco:TStringList;
  i:integer;


  function StrToBool(const str1:string):Boolean;
  var
    int1:integer;
  begin
    int1:=StrToIntDef(str1,0);
    if int1 = 0 then Result:=False
      else Result:=True;
  end;

begin
  Sco1:=TStringList.Create;
  ExSco:=TStringList.Create;
  try
    Sco1.LoadFromFile(FN1);
    ExSco.LoadFromFile(FN1);
    Form1.BGM1.FileName:=ExePath + 'Sound\' + ChangeFileExt(ExtractFileName(FN1), '.mp3');
    Form1.BGM1.Open();
    Form1.Speed1.Position:=5;
    for i:= 0 to ExSco.Count - 1 do
    begin
      try
        Sco1.CommaText:=ExSco[i];
        Self.Add(StrToIntDef(Sco1[0],1000),
                 StrToIntDef(Sco1[1],0)
                );
      except
        ShowMessage(IntToStr(i)+'sɃG[܂B');
      end;
    end;
  except
    FreeAndNil(Sco1);
    FreeAndNil(ExSco);
  end;
end;

procedure TScore.Add(const Tim:Integer;Kin:Byte);
begin
  inherited Add(CreateBar(Kin,Tim));
end;

function TScore.Get(Index: Integer): PBar;
begin
  Result :=  PBar( inherited Get(Index) );
end;

procedure TScore.Put(Index: Integer; const Value: PBar);
begin
  inherited Put( Index, Value );
end;

procedure TScore.SaveScore(Str : String);
var
  Sc1:TStringList;
  i:integer;
begin
  try
    Sc1:=TStringList.Create();
    for i:= 0 to Score.Count - 1 do
    begin
      Sc1.Add(IntToStr(Score[i].Timing) +',' + IntToStr(Score[i].Kind));
    end;
    Sc1.SaveToFile(Str);
  finally
    FreeAndNil(Sc1);
  end;
end;

procedure TForm1.DXDraw1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  i:integer;
  RecIn:Boolean;
begin
  RecIn:=false;
  for i:= 0 to Score.Count - 1 do
  begin
    if HitCheck(Rect(Mouse1,Point(Mouse1.X + 1,Mouse1.Y + 1)),
                            Rect(BARX,Score[i].Y - 5,BARX + 50,Score[i].Y + 5)
                            ) then
    begin
      RecIn:=True;
    end;
  end;
  if not RecIn then
  begin
    Rec:=Rect(Mouse1,Mouse1);
    RecMoving:=True;
  end;
end;

function SortComp(Item1, Item2: Pointer): Integer;
begin
  Result := PBar(Item1).Timing - PBar(Item2).Timing;
end;

procedure TForm1.DXDraw1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  i,j,Max1,Min1,Dis:integer;
  MRec:TList;
  SFlag:Boolean;
begin
  if RecMoving then
  begin
    Rec.BottomRight :=Mouse1;
    RecMoving :=False;
    MRec :=TList.Create();
    try
      Score.Sort(SortComp);
      for i := 0 to Score.Count - 1 do
      begin
        with Score[i]^ do
        begin
          if PointInRect(Point(BARX,Trunc(JUSTPOSI - (Timing - BGM1.Position) * Pow)),
                         Rec
                         ) then
          begin
            SFlag :=False;
            for j := i+1 to Score.Count - 1 do
            begin
              if Score[i].Timing = Score[j].Timing then SFlag:=True;
            end;
            if not SFlag then MRec.Add(Score[i]);
          end;
        end;
      end;
      if (MRec.Count = 2) and (GetKeyState(VK_Shift)<0) then
      begin
        Min1 :=(PBar(MRec[0]).Timing + PBar(MRec[1]).Timing) div 2;
        PBar(MRec[0]).Timing:=Min1;
        PBar(MRec[1]).Timing:=Min1;
      end
        else
      begin
        Min1 :=999999999;
        Max1 :=0;
        for i:= 0 to MRec.Count-1 do
        begin
          Min1 :=Min(PBar(MRec[i]).Timing,Min1);
          Max1 :=Max(PBar(MRec[i]).Timing,Max1);
        end;
        if MRec.Count-1 <> 0 then Dis :=(Max1 - Min1) div (MRec.Count-1) else Dis:=0;
        for i:= 0 to MRec.Count-1 do
        begin
          PBar(MRec[i]).Timing :=Min1 + i * Dis;
        end;
      end;
    finally
      FreeAndNil(MRec);
    end;
  end;
end;

procedure TForm1.DXDraw1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  if GetKeyState(VK_LButton) < 0 then Rec.BottomRight:=Mouse1;
end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
begin
  Score.SaveScore(OD1.FileName);
end;

procedure TForm1.Speed1Change(Sender: TObject);
begin
  Pow:=Speed1.Position * 0.01;
  Form1.SetFocus();
end;

procedure TForm1.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  Speed1.Enabled := True;
end;
function HitCheck(const RectA,RectB:TRect):boolean;
var
  tmprect:TRect;
begin

  //dȂĂtrue
  Result:=IntersectRect(tmprect,RectA,RectB);

end;


procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if ADJ = EditMode then
  begin
    Speed1.Enabled := False;
  end;
end;

end.
