unit Shadow;

//TruncgRoundgłUnDelphiX̂قł
//RoundgĂ݂Ȃ̂łɂ킹܂

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DXDraws, AppEvnts, DXClass, MMSystem, DXSprite, MPlayer, Ddidex,
  UHero, UConsts, UVector, UBoss, UScore, colli3DX, DXSounds;

type
  TScene = (TitleScene = 1 , MenuScene , BattleScene , RetryScene, ResultScene);

  TForm1 = class(TDXForm)
    DXDraw1: TDXDraw;
    ApplicationEvents1: TApplicationEvents;
    DXSpriteEngine1: TDXSpriteEngine;
    DXImageList1: TDXImageList;
    MediaPlayer1: TMediaPlayer;
    Input1: TDDIDEX;
    DXSound1: TDXSound;
    DXWaveList1: TDXWaveList;
    procedure ApplicationEvents1Idle(Sender: TObject; var Done: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormDestroy(Sender: TObject);
  private
    { Private 錾 }
    procedure DrawTitleName();

    procedure ShowTitleScene();
    procedure ShowMenuScene();
    procedure ShowBattleScene();
    procedure DrawBattleScene(); //ѐǁc
    procedure ShowRetryScene();
    procedure ShowResultScene();
    //procedure ShowBubblesScene();

    procedure SetUpBattleScene();
    //procedure SetUpBubblesScene();
  public
    { Public 錾 }
  end;

  TStage = record
    Name:String;
    MusicTitle:String;
  end;

var
  Form1: TForm1;
  LeftButton,RightButton : Byte;
  UseMouse : Boolean = False;

  StageNumber : integer = 1;
  Stages : array[1..3] of TStage;
  ExePath : String;

  Scene : TScene;
  Ready : Boolean;

implementation

{$R *.dfm}


procedure TForm1.FormCreate(Sender: TObject);
begin
  Randomize;

  Input1.Initialize();
  DXDraw1.Initialize();
  DXSound1.Initialize();
  Scene := TitleScene;
  Score := TScore.Create();
  Hero := THeroSprite.Create(DXSpriteEngine1.Engine);
  MediaPlayer1.Wait := True;
  ExePath := ExtractFilePath(Application.ExeName);

  Stages[1].Name := 'Final Battle';
  Stages[1].MusicTitle := 'Last Boss';
  Stages[2].Name := 'Pokey Strikes Back!';
  Stages[2].MusicTitle := '|[L[̃|[L[';
  Stages[3].Name := 'Exit';

  RightButton := 0;
  LeftButton := 0;
end;

var
  NowTime,Beforetime :Int64;
procedure TForm1.ApplicationEvents1Idle(Sender: TObject;
  var Done: Boolean);

  procedure ScanButtons();
  begin
    if UseMouse then Input1.Scan(DI_MOUSE)
      else Input1.OrScan([DI_Joy1, DI_KEYB]);
    if Input1.Buttons[DI_B1] then
    begin
      if LeftButton < 254 then Inc(LeftButton);
    end else
      LeftButton := 0;

    if Input1.Buttons[DI_B2] then
    begin
      if RightButton < 254 then Inc(RightButton);
    end else
      RightButton := 0;
  end;

begin

  NowTime := timeGetTime;
  if (NowTime - BeforeTime) < FPS then
  begin
    Sleep(1);
    Done := False;
    Exit;
  end;

  ScanButtons();

  if not DXDraw1.CanDraw then Exit;
  case Scene of
    TitleScene : ShowTitleScene();
    MenuScene  : ShowMenuScene();
    BattleScene : ShowBattleScene();
    RetryScene : ShowRetryScene();
    ResultScene : ShowResultScene();
  end;


  BeforeTime := NowTime;
  Done :=False;

end;

var
  Prep:Boolean;//uReady?v
procedure TForm1.ShowBattleScene();

  procedure ChangeScene();
  var
    i : integer;
  begin
    if Hero = nil then Scene := RetryScene else
    if (RightButton > RUIN_LIFETIME) and
       (LeftButton > RUIN_LIFETIME) then
    begin
      Scene := TitleScene;
      with DXSpriteEngine1.Engine do
      begin
        for i := 0 to Count - 1 do
        begin
          if not(Items[i] is THeroSprite) then Items[i].Dead();
        end;
        Dead();
      end;
      Hero.Reset();
      MediaPlayer1.Stop();
    end else
    if DXSpriteEngine1.Engine.Count = 1 then
    begin
      Scene := ResultScene;
      with DXSpriteEngine1.Engine do
      begin
        for i := 0 to Count - 1 do
        begin
          if not(Items[i] is THeroSprite) then Items[i].Dead();
        end;
        Dead();
      end;
      Hero.Reset();
    end;
  end;
begin
  if Prep then
  begin
    if not (not Ready) and (Hero.HP >= HERO_HP_MAX) then
    begin
      MediaPlayer1.Play();
      Hero.HP := HERO_HP_MAX;
      Prep := False;
    end;
    Ready := Hero.HP >= HERO_HP_MAX ;
    Hero.IntactTime := 5;
  end;
  Score.Scan();
  with DXSpriteEngine1.Engine do
  begin
    if Ready then
    begin
      if Hero <> nil then Move(1);
      Dead();
    end
      else Hero.Move(1);
  end;
  DrawBattleScene();
  ChangeScene();
end;

procedure TForm1.DrawBattleScene();

  procedure DrawHPMeter();
  var
    HPDisHei : Word;
  begin
    with DXImageList1.Items.Find('Meter') do
    begin
      HPDisHei := (EARTH_POS - Height) div 2;
      Draw(DXDraw1.Surface, 50,DXDraw1.Height - EARTH_POS + HPDisHei,0);
    end;
    with DXDraw1.Surface.Canvas do
    begin
      if Hero <> nil then
      begin
        Hero.SurfaceHP := (Hero.SurfaceHP + Hero.HP) * 0.5;
        if Hero.SurfaceHP > PINCH then Brush.Color := clLime
          else Brush.Color := clRed;
        FillRect(Rect(51, DXDraw1.Height - EARTH_POS + HPDisHei + 1,
                      51 + Round(Hero.SurfaceHP), DXDraw1.Height - HPDisHei - 2));
        if Hero.SurfaceHP > PINCH then Brush.Color := $b0FFb0
          else Brush.Color := TColor($b0b0FF);
        FillRect(Rect(51, DXDraw1.Height - EARTH_POS + HPDisHei + 4,
                      51 + Round(Hero.SurfaceHP), DXDraw1.Height - HPDisHei - 6));

        font.Size := 10;
        Brush.Color := ThemeColor;
        if Hero.DTick > HERO_DTICK_MAX - 2 then Font.Color := clred;
        TextOut(5,DXDraw1.Height - EARTH_POS + HPDisHei, IntToStr(Hero.DTick) + '/' + IntToStr(HERO_DTICK_MAX));
        Font.Color := clBlack;
      end;
    end;
  end;

begin
  DXDraw1.Surface.Fill( DXDraw1.Surface.ColorMatch(ThemeColor) );

  if Hero <> nil then
  begin
    if Hero.ComboCount > 0 then
    begin
      with DXDraw1.Surface.Canvas do
      begin
        //R{
        Font.Size := 75;
        Brush.Color := ThemeColor;
        TextOut(0,0, IntToStr(Hero.ComboCount) + 'Hit!');
        Release;
      end;
    end;
  end;
  DXSpriteEngine1.Draw();

  if Prep then
  begin
    //Ready?cGo!
    if Hero <> nil then
    begin
      Hero.HP := Hero.HP + 6.5;
      with DXImageList1.Items do
      begin
        if Hero.HP < HERO_HP_MAX - 60 then
          Find('Ready').Draw(DXDraw1.Surface, 100, 100, 0)
        else Find('Go').Draw(DXDraw1.Surface, 130, 90, 0);
      end;
    end;
  end;

  DrawHPMeter();


  with DXDraw1.Surface.Canvas do
  begin
    //n
    Pen.Color := clBlack;
    Pen.Width := 3;
    MoveTo(0, Height - EARTH_POS);
    LineTo(Width, Height - EARTH_POS);
    Release();
  end;

  DXDraw1.Flip();
end;

var
  RetryFocusNumber : integer = 1;
procedure TForm1.ShowRetryScene();
  procedure FinishBattleScene();
  var
    i:integer;
    Finished : Boolean;
  begin
    if Hero = nil then
    begin
      with DXSpriteEngine1.Engine do
      begin
        Finished := True;
        for i := 0 to Count - 1 do
        begin
          if Items[i] is TRuinSprite then Finished := False;
        end;
        if Finished then
        begin
          for i := 0 to Count - 1 do
          begin
            Items[i].Dead();
          end;
          Hero := THeroSprite.Create(DXSpriteEngine1.Engine);
        end;
        Dead();
      end;
    end;
  end;

  procedure DrawRetryScene();
  var
    i:integer;
  begin
    if Hero = nil then
    begin
      DrawBattleScene();
      RetryFocusNumber := 1;
    end
      else
    begin
      DXDraw1.Surface.Fill( DXDraw1.Surface.ColorMatch(ThemeColor) );
      with DXDraw1.Surface.Canvas do
      begin
        with Font do
        begin
          Size := 40;
          Color := clBlack;
        end;
        Brush.Color := ThemeColor;
        TextOut(GAMETITLE_LEFT , GAMETITLE_TOP , 'Continue?');
      end;
      Hero.X := MENU_LEFT + 25;
      Hero.Y := MENU_TOP + MENU_DISTANCE * RetryFocusNumber + 18 - CONTINUE_MENU_GAP;
      with DXDraw1.Surface.Canvas do
      begin
        Font.Size := MENU_FONT_SIZE;
        for i := 1 to 2 do
        begin
          case i of
            1 : TextOut(MENU_LEFT + Font.Size * 2 ,
                        MENU_TOP + i * MENU_DISTANCE - CONTINUE_MENU_GAP, 'Yes');
            2 : TextOut(MENU_LEFT + Font.Size * 2 ,
                        MENU_TOP + i * MENU_DISTANCE - CONTINUE_MENU_GAP, 'No');
          end;
          if RetryFocusNumber = i then
          begin
            if LeftButton = 1 then
            begin
              case i of
                1 : SetUpBattleScene();
                2 : Scene := TitleScene;
              end;
              DXWaveList1.Items.Find('Snare').Play(False);
            end;
          end;
        end;
        Release();
      end;
    end;
    with DXSpriteEngine1 do
    begin
      Move(1);
      Draw();
    end;
    DXDraw1.Flip();
  end;
begin
  MediaPlayer1.Stop();
  FinishBattleScene();
  if Input1.AStick.Y < 0 then RetryFocusNumber := 1;
  if Input1.AStick.Y > 0 then RetryFocusNumber := 2;
  DrawRetryScene();
end;

var
  FocusNumber : integer = 1;
  CTick : integer;
procedure TForm1.ShowMenuScene();

  procedure DrawMenu();
  var
    i:integer;
  begin
    DXDraw1.Surface.Fill( DXDraw1.Surface.ColorMatch(ThemeColor) );


    DrawTitleName();
    with DXDraw1.Surface.Canvas do
    begin
      with Font do
      begin
        Size := MENU_FONT_SIZE;
        Color := clBlack;
      end;
      Brush.Color := ThemeColor;
      if Hero <> nil then
      begin
        Hero.X := MENU_LEFT + 25;
        Hero.Y := MENU_TOP + MENU_DISTANCE * FocusNumber + 18;
      end;
      for i := Low(Stages) to High(Stages) do
      begin
        TextOut(MENU_LEFT + 50, MENU_TOP + i * MENU_DISTANCE, Stages[i].Name);
        if i = FocusNumber then
        begin
          if LeftButton = 1 then
          begin
            case i of
              1,2 : begin
                StageNumber := i;
                SetUpBattleScene();
                DXWaveList1.Items.Find('Snare').Play(False);
              end;
              3 : Hero.Dead();//èèèè
            end;
          end;
        end;
      end;
    end;
    DXDraw1.Surface.Canvas.Release();

    with DXSpriteEngine1 do
    begin
      Move(1);
      Draw();
      Dead();
      if Engine.Count = 0 then Form1.Close()
    end;

    DXDraw1.Flip();
  end;

begin
  Dec(CTick);
  if Input1.AStick.Y = 0 then CTick := 0;
  if CTick <= 0 then
  begin
    if (Input1.AStick.Y < 0) and (FocusNumber > Low(Stages)) then
    begin
      Dec(FocusNumber);
      CTick := 6;
    end;
    if (Input1.AStick.Y > 0) and (FocusNumber < High(Stages)) then
    begin
      Inc(FocusNumber);
      CTick := 6;
    end;
  end;
  DrawMenu();
end;

procedure TForm1.DrawTitleName();
//gƂReleaseYɒ
begin
  with DXDraw1.Surface.Canvas do
  begin
    with Font do
    begin
      Size := 80;
      Name := 'Myriad Apple';
      Style := [fsBold];
      Color := clBlack;
    end;
    Brush.Color := ThemeColor;
    TextOut(GAMETITLE_LEFT , GAMETITLE_TOP , 'iShadow');
  end;
end;

procedure TForm1.ShowTitleScene();

  procedure DrawTitle();
  begin
    DXDraw1.Surface.Fill( DXDraw1.Surface.ColorMatch(ThemeColor) );
    DrawTitleName();
    with DXDraw1.Surface.Canvas do
    begin

      with Font do
      begin
        Size := 40;
        Color := clBlack;
      end;
      Brush.Color := ThemeColor;
      TextOut(100 , 230 , 'Push Any Key.');

      Release();
    end;

    DXDraw1.Flip();
  end;

  procedure ChangeScene();
  begin
    if LeftButton = 1 then Scene := MenuScene;
  end;

begin
  DrawTitle();
  ChangeScene();
end;

var
  WaitTick : integer;
procedure TForm1.ShowResultScene();
  procedure DrawResult();
  begin
    DXDraw1.Surface.Fill(DXDraw1.Surface.ColorMatch(ThemeColor));
    with DXDraw1.Surface.Canvas do
    begin
      font.Color := clBlack;
      brush.Color := themecolor;
      font.Size := 30;
      TextOut(WaitTick * 5, 200, '"iShadow"');
      font.Size := 20;
      TextOut(WaitTick * 5 - STAFF_DISTANCE, 200, 'Producer');
        TextOut(WaitTick * 5 - STAFF_DISTANCE, 250, 'Satoru Miyahara');
      TextOut(WaitTick * 5 - STAFF_DISTANCE * 2, 200, 'Director');
        TextOut(WaitTick * 5 - STAFF_DISTANCE * 2, 250, 'Satoru Miyahara');
      TextOut(WaitTick * 5 - STAFF_DISTANCE * 3, 200, 'GameDesign');
        TextOut(WaitTick * 5 - STAFF_DISTANCE * 3, 250, 'Satoru Miyahara');
      TextOut(WaitTick * 5 - STAFF_DISTANCE * 4, 200, 'Art Director');
        TextOut(WaitTick * 5 - STAFF_DISTANCE * 4, 250, 'Satoru Miyahara');
      TextOut(WaitTick * 5 - STAFF_DISTANCE * 5, 200, 'Tools Program');
        TextOut(WaitTick * 5 - STAFF_DISTANCE * 5, 250, 'Satoru Miyahara');
      TextOut(WaitTick * 5 - STAFF_DISTANCE * 6, 200, 'Illustration');
        TextOut(WaitTick * 5 - STAFF_DISTANCE * 6, 250, 'Satoru Miyahara');

      font.Size := 80;
      TextOut(50, 50, 'You Win!');
      font.Size := 20;
      TextOut(50, 300, 'Thanks for playing!!');
      Release();
    end;
    with DXImageList1.Items.Find('Tupod') do
    begin
      Draw(DXDraw1.Surface,
           Form1.ClientWidth - Width ,
           Form1.ClientHeight - Height , 0);
    end;
    DXDraw1.Flip();
  end;

  procedure ChangeScene();
  begin
    Inc(WaitTick);
    if LeftButton > 0 then Inc(WaitTick,2);
    if ((WaitTick * 5 - STAFF_DISTANCE * 6 > Form1.ClientWidth) and (LeftButton > 0)) or
       (WaitTick * 5 - STAFF_DISTANCE * 8 > Form1.ClientWidth)then
    begin
      Scene := MenuScene;
      WaitTick := 0;
    end;
  end;

begin
  DrawResult();
  ChangeScene();
end;

procedure TForm1.SetUpBattleScene();
begin
  Scene := BattleScene;
  Hero.Reset();

  with DXImageList1.Items.Find('Boss') do
  begin
    case StageNumber of
      1 : begin
        Picture.LoadFromFile(ExePath + 'Image\Bowser.bmp');
        Restore();
        TBowserSprite.Create(DXSpriteEngine1.Engine);
        Score.Load();
      end;
      2 : begin
        Picture.LoadFromFile(ExePath + 'Image\Pokey.bmp');
        Restore();
        RealNumber := Random(3) + 1;
        TPokeySprite.Create(DXSpriteEngine1.Engine).Reset(1);
        TPokeySprite.Create(DXSpriteEngine1.Engine).Reset(2);
        TPokeySprite.Create(DXSpriteEngine1.Engine).Reset(3);
        Score.Load();
      end;
    end;
  end;
  with MediaPlayer1 do
  begin
    FileName := ExePath + '\Sound\' + Stages[StageNumber].MusicTitle + '.mp3';
    Open();
    Rewind;
  end;

  Prep := True;
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  Scene := TitleScene;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin 
  FreeAndNil(Score);
end;

end.
