unit UBullet;

interface
uses
  DXSprite, UVector, UConsts, Types,Math, SysUtils, UScore;

type
  TBulletSprite = class(TImageSpriteEx)
  private
    FVector : TVector2D;
    FKind : Byte;
  protected
    procedure DoMove(MoveCount: Integer); override;
  public
    constructor Create(Parent : TSprite); override;
    destructor Destroy(); override;

    procedure Reset(const NewKind: Byte; NewX, NewY: Double; NewVector: TVector2D);

    property Kind : Byte read FKind;
    property Vector : TVector2D read FVector;
  end;

implementation

uses Shadow, UHero;

procedure TBulletSprite.DoMove(MoveCount: Integer);
begin
  inherited;
  case Kind of
    1,2 : FVector.Y := Vector.Y + 1;
  end;
  X := X + Vector.X;
  Y := Y + Vector.Y;

  if Hero <> nil then
  begin
    if (Hero.DashType = None) and (Hero.IntactTime = 0) then
    begin
      if (Sqr(X + Width div 2 - Hero.X) < Sqr((Width + Hero.Width) div 2)) and
         (Sqr(Y + Height div 2 - Hero.Y) < Sqr((Height + Hero.Height) div 2)) then
      begin
        Hero.HP := Hero.HP - BULLET_AP;
        Hero.IntactTime := BULLET_INTACT_TIME;
      end;
    end;
  end;
  if Y > Form1.ClientHeight + Height then Dead();
  Visible := True;
end;

constructor TBulletSprite.Create(Parent : TSprite);
begin
  inherited;
  Image := Form1.DXImageList1.Items.Find('Bullet1');
  Collisioned := False;
  Z := 1;
end;

destructor TBulletSprite.Destroy();
begin
  inherited;
end;

procedure TBulletSprite.Reset(const NewKind: Byte; NewX, NewY : Double; NewVector: TVector2D);
begin
  FVector := NewVector;
  FKind := NewKind;
  X := NewX;
  Y := NewY;
  case Kind of
    2: begin
      Width := 412;
      Height := 412;
    end;
  end;
end;

end.
