unit UHero;
//U͈͂̓^C~Oɂ킹đ召

interface

uses
  DXSprite, DXInput, UVector, UConsts, Ddidex, Windows, Math, Types,
  UScore,Graphics, SysUtils;

type

  {TTerritorySprite = class(TImageSprite)
  private
  protected
    procedure DoMove(MoveCount: Integer); override;
    function GetBoundsRect(): TRect; override;
  public
    constructor Create(Parent : TSprite); override;
    destructor Destroy(); override;
  end;
  }
  TRuinType = (Ruin = 1, Note1, Note2, Note3, Note4);
  TRuinSprite = class(TImageSprite)
  private
    FTick : integer;
    FKind : TRuinType;
  protected
    procedure DoMove(MoveCount: Integer); override;
  public
    Vector : TVector2D;

    constructor Create(Parent : TSprite); override;
    procedure MakeNote(const NewKind : TRuinType);
    property Tick : integer read FTick;
    property Kind : TRuinType read FKind;
  end;

  TDashType = (None, Right, Left, Up, Down, UpRight, UpLeft, DownRight, DownLeft);
  THeroSprite = class(TImageSprite)
  private
    FVector : TVector2D;
//-    FTerritory : TTerritorySprite;
    FJumping : Boolean;
    FDashType : TDashType;
    FComboCount : Byte;
    FHP : Double;
    FIntactTime : Byte;
    FDTick : Word;//_bV񐔃JE^[

    procedure SetHP(const Value : Double);
  protected
    procedure DoMove(MoveCount: Integer); override;
    function GetBoundsRect(): TRect; override;
  public
    SurfaceHP : Double;
    constructor Create(Parent : TSprite); override;
    destructor Destroy(); override;

    procedure Reset();

    property Vector : TVector2D read FVector write FVector;
    property Jumping : Boolean read FJumping;
    property DashType : TDashType read FDashType;
    property ComboCount : Byte read FComboCount write FComboCount;
    property HP : Double read FHP write SetHP;
    property IntactTime : Byte read FIntactTime write FIntactTime;
    property DTick : Word read FDTick;
  end;
var
  Hero : THeroSprite;

implementation

uses
  Shadow, UBoss;

procedure THeroSprite.SetHP(const Value : Double);
begin
  if Value < HP then
  begin
    if HP < PINCH then FHP := (HP * 9 + Value) * 0.1
      else if HP > COZY then FHP := HP - (HP - Value) * 1.4
      else FHP := Value;
  end
    else FHP := Value;
  if Value < 0 then FHP := 0;
  if Value > HERO_HP_MAX then FHP := HERO_HP_MAX;
end;

constructor THeroSprite.Create(Parent : TSprite);
begin
  inherited;
  Image := Form1.DXImageList1.Items.Find('Hero');

//  FTerritory := TTerritorySprite.Create(Self);
  Reset();
  Z := 2;
  AnimCount := 1;
end;

procedure THeroSprite.Reset();
begin
  FVector := CreateVector2D(0,0);
  X := Form1.ClientWidth div 2;
  Y := Form1.ClientHeight - EARTH_POS - Width;
  FJumping := True;
  FDashType := None;
  FDTick := 0;
  FComboCount := 0;
  FIntactTime := 0;
  FHP := 10;
  Visible := True;
end;

destructor THeroSprite.Destroy();
var
  i:integer;
  NewSin,NewCos : Extended;
begin
  inherited;
  Hero := nil;
  if Scene in [BattleScene,MenuScene] then
  begin
    for i:= 0 to 5 do
    begin
      SinCos(Pi / 3 * i, NewSin, NewCos);
      with TRuinSprite.Create(Form1.DXSpriteEngine1.Engine) do
      begin
        Vector.X := NewCos * RUIN_SPEED;
        Vector.Y := NewSin * RUIN_SPEED;
        X := Self.X;
        Y := Self.Y;
      end;
    end;
    Form1.DXWaveList1.Items.Find('End').Play(False);
  end;
end;

procedure THeroSprite.DoMove(MoveCount: Integer);
  procedure Dash();
  var
    HeroSpeed : Integer;
  begin
    if (Form1.Input1.Buttons[DI_B1]) and (LeftButton = 1) and
       (DTick < HERO_DTICK_MAX ) and (DashType = None)  then
    begin
      Inc(FDTick);
      HeroSpeed := HERO_DASH_SPEED - (HERO_DTICK_MAX - Hero.DTick) div 2;
      if (Form1.Input1.AStick.X <> 0) and (Form1.Input1.AStick.Y <> 0) then
      begin
        SetVector2DLength(FVector,HeroSpeed);
        if Form1.Input1.AStick.Y < 0 then
        begin
          if Form1.Input1.AStick.X < 0 then
          begin
            FDashType := UpLeft;
            FVector.X := -HeroSpeed * 0.7;
            FVector.Y := -HeroSpeed * 0.7;
          end;
          if Form1.Input1.AStick.X > 0 then
          begin
            FDashType := UpRight;
            FVector.X := HeroSpeed * 0.7;
            FVector.Y := -HeroSpeed * 0.7;
          end;
        end
          else
        begin
          if Jumping then
          begin
            if Form1.Input1.AStick.X < 0 then
            begin
              FDashType := DownLeft;
              FVector.X := -HeroSpeed * 0.7;
              FVector.Y := HeroSpeed * 0.7;
            end;
            if Form1.Input1.AStick.X > 0 then
            begin
              FDashType := DownRight;
              FVector.X := HeroSpeed * 0.7;
              FVector.Y := HeroSpeed * 0.7;
            end;
          end;
        end;
      end
        else if Form1.Input1.AStick.X < 0 then
      begin
        FDashType := Left;
        FVector.X := -HeroSpeed;
        FVector.Y := 0;
      end
        else if Form1.Input1.AStick.X > 0 then
      begin
        FDashType := Right;
        FVector.X := HeroSpeed;
        FVector.Y := 0;
      end
        else if Jumping then
      begin
        if Form1.Input1.AStick.Y < 0 then
        begin
          FDashType := Up;
          FVector.X := 0;
          FVector.Y := -HeroSpeed;
        end
          else if Form1.Input1.AStick.Y > 0 then
        begin
          FDashType := Down;
          FVector.X := 0;
          FVector.Y := HeroSpeed;
        end;
      end;
    end;
  end;

  procedure CheckSideWall();
  begin
    if X + Vector.X < Width then
    begin
      X := Width;
      FVector.X :=0;
      if Dashtype <> None then
      begin
        FDashType := none;
        FVector.Y := 0;
      end;
    end;
    if X + Vector.X > Form1.ClientWidth - Width  then
    begin
      X := Form1.ClientWidth - Width;
      FVector.X :=0;
      if Dashtype <> None then
      begin
        FDashType := none;
        FVector.Y := 0;
      end;
    end;
  end;

  procedure CheckEarth();
  begin
    if Y + Vector.Y >= Form1.ClientHeight - Height div 2 - EARTH_POS then
    begin
      FJumping := False;
      Y := Form1.ClientHeight - Height div 2 - EARTH_POS;
      FVector.Y := 0;
      FDTick := 0;
      if DashType = Down then
      FDashType := none;
      FComboCount := 0;
    end;
  end;

  procedure CheckCeiling();
  begin
    if Y - Height div 2 + Vector.Y < 0 then
    begin
      Y := Height div 2;
      FVector.Y := -Vector.Y * 0.5;
      if DashType in [Up, UpRight, UpLeft] then
        FDashType := none;
    end;
  end;

  procedure Jump();
  begin
    if not Jumping then
    begin
      if Form1.Input1.AStick.Y < 0 then
      begin
        FJumping := True;
        FVector.Y := Form1.Input1.AStick.Y * ASTICK_POWER * 22;
      end;
    end;
  end;

  procedure MoveHero();
  begin
    if DashType <> None then
    begin
      //ă_bV
      if LeftButton = 1 then
      begin
        FDashType := None;
        FVector := CreateVector2D(0,0);
        Dash();
      end;
      //_bVI
      if GetVector2DLength(Vector) < HERO_DASH_SPEEDDOWN then
      begin
        FDashType := None;
        FIntactTime := HERO_DASH_INTACT_TIME;
      end
        else
      begin
        //
        SetVector2DLength(FVector, GetVector2DLength(Vector) - HERO_DASH_SPEEDDOWN);
      end;
    end
      else
    begin
      //_bVȂ
      if Vector.X * Form1.Input1.AStick.X > 0 then//
        FVector.X := Vector.X  + Form1.Input1.AStick.X * ASTICK_POWER * 0.5
      else FVector.X := Vector.X  + Form1.Input1.AStick.X * ASTICK_POWER;  //ٕ

      if Vector.X > HERO_SPEED then FVector.X := HERO_SPEED;
      if Vector.X < -HERO_SPEED then FVector.X := -HERO_SPEED;
    end;
  end;
begin
  inherited;

  if Scene = BattleScene then
  begin
    AnimPos := Ord(DashType <> None);
    if Ready then
    begin
      HP := HP - 2.25;
      if IntactTime > 0 then Dec(FIntactTime);
      if HP <= 0 then Dead();
      Visible := IntactTime mod 2 = 0;
    end;

    if DashType in [None,Up] then FVector.Y := FVector.Y + 1.2;//d

    CheckEarth();
    CheckCeiling();
    MoveHero();
    Dash();
    Jump();
    CheckSideWall();
  end;

  X := X + Vector.X;
  Y := Y + Vector.Y;
end;


function THeroSprite.GetBoundsRect(): TRect;
var
  NewWidth, NewHeight: integer;
begin
  NewWidth := Width div 2;
  NewHeight := Height div 2;

  Result := Bounds(Round(WorldX) - NewWidth,
                   Round(WorldY) - NewHeight,
                   NewWidth,
                   NewHeight);
end;

procedure TRuinSprite.DoMove(MoveCount: Integer);
begin
  inherited;
  if Kind <> Ruin then
  begin
    Vector.Y :=Vector.Y + 1.5;
    inc(FTick);
    if Y > Form1.ClientHeight then Dead();
  end
    else
  begin
    inc(FTick);
    if Tick > RUIN_LIFETIME then Dead();
  end;
  X := X + Vector.X;
  Y := Y + Vector.Y;
end;

constructor TRuinSprite.Create(Parent : TSprite);
begin
  inherited;
  Image := Form1.DXImageList1.Items.Find('Ruin');
  Collisioned := False;
  FTick := 0;
  FKind := Ruin;
  Z := 3;
end;

procedure TRuinSprite.MakeNote(const NewKind : TRuinType);
begin
  FKind := NewKind;
  Image := Form1.DXImageList1.Items.Find('Note' + IntToStr(Ord(NewKind) - 1));
  if Scene = BattleScene then
  begin
    with  Form1.DXWaveList1.Items do
    begin
      case Hero.ComboCount of
        0..2 : begin
          Find('Bass').Play(False);
          Hero.HP := Hero.HP + 10;
        end;
        3..8 : begin
          Find('Snare').Play(False);
          Hero.HP := Hero.HP + 17;
        end;
        9..15 : begin
          Find('SmallHit').Play(False);
          Hero.HP := Hero.HP + 25;
        end
          else
        begin
          Find('BigHit').Play(False);
          Hero.HP := Hero.HP + 42;
        end;
      end;
    end;
  end;
end;


end.
